# include <iostream>
# include <map>
# include <algorithm>
# include "segment.h"
//# include "Lgrader.cpp"
using namespace std;

const int MAX=3e6+11;
long long a[MAX];
map<long long, long long> m[MAX];

long long max_segment(vector<int> A)
{
    int n=A.size();
    for(int i=0;i<n;i++) a[i+1]=A[i];

    m[1][a[1]]=1;
    long long ans=n;
    for(int i=2;i<=n;i++)
    {
        m[i][a[i]]=1;
        for(pair<long, long> p: m[i-1])
        {
            long long d=p.first;
            d=__gcd(d,a[i]);
            m[i][d]=max((long long)m[i][d],p.second+1LL);
        }
    }

    for(int i=1;i<=n;i++)
    {
        for(pair<long long, long long> p: m[i])
        {
            ans=max(ans,p.first*p.second);
        }
    }

    return ans;
}
