# include <iostream>
# include <unordered_map>
# include <algorithm>
# include "segment.h"
//# include "Lgrader.cpp"
using namespace std;

const int MAX=4e6+11;
int a[MAX];
unordered_map<int, int> m[2];
int n;

int f(int x)
{
    //cout<<"->"<<x<<endl;
    return (x&1LL);
}

int pw2[31];

long long solve2()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<=30;j++) if(a[i]==pw2[j]) a[i]=j;
    }

    long long ans=0;
    for(int k=0;k<=30;k++)
    {
        int br=0;
        for(int i=1;i<=n;i++)
        {
            if(a[i]>=k) br++;
            else ans=max(ans,(long long)br*(1LL<<k));
        }

        if(br>0) ans=max(ans,(long long)br*(1LL<<k));
    }

    return ans;
}

long long max_segment(vector<int> A)
{
    pw2[0]=1;
    for(int i=1;i<=30;i++) pw2[i]=pw2[i-1]*2;

    n=A.size();
    for(int i=0;i<n;i++) a[i+1]=A[i];

    bool fl=1;
    for(int i=1;i<=n;i++)
    {
        bool f2=0;
        for(int j=0;j<=30;j++) if(a[i]==pw2[j]) f2=1;

        if(!f2) fl=0;
    }

    if(fl) return solve2();

    m[1][a[1]]=1;
    long long ans=n;
    ans=max(ans,(long long)a[1]);

    for(int i=2;i<=n;i++)
    {
        m[f(i)].clear();
        m[f(i)][a[i]]=1;
        for(pair<int, int> p: m[f(i-1)])
        {
            //cout<<"-->"<<p.first<<" "<<p.second<<endl;

            int d=__gcd(a[i],p.first);
            //cout<<"->"<<d<<endl;
            m[f(i)][d]=max(m[f(i)][d],p.second+1);
        }

        for(pair<int, int> p: m[f(i)])
        {
            ans=max(ans,(long long)p.first*p.second);
        }
    }

    return ans;
}
/*
3
3 3 3
*/
