#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXN = 101;
llong N, K;
llong Trees[MAXN];
pair<llong, llong> Child[MAXN];
bool Station[MAXN];
llong NewStation;
llong Visited[MAXN];
llong Marker;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K;

    for(llong i = 1; i <= N; i++)
    {
        llong V, W; cin >> Trees[i] >> V >> W;
        Child[i] = {V, W};
    }

    Station[0] = true;
}

llong Dfs(llong U, llong T, llong W)
{
    if(Station[U] || U == NewStation)
    {
        return W;
    }

    if(Visited[U] == Marker)
    {
        return Dfs(Child[U].first, T, W + Child[U].second * T);
    }
    else
    {
        Visited[U] = Marker;
        return Dfs(Child[U].first, T + Trees[U], W + (llong)(Child[U].second * (T + Trees[U])));
    }
}

void Solve()
{
    llong Answer = 0;

    for(llong i = 1; i <= K; i++)
    {
        llong Min = 1e18, U;

        for(llong V = 1; V <= N; V++)
        {
            if(Station[V])
            {
                continue;
            }

            NewStation = V;
            llong W = 0;

            Marker++;

            for(llong j = 1; j <= N; j++)
            {
                if(Visited[j] == Marker)
                {
                    continue;
                }

                W += Dfs(j, 0, 0);
            }

            ///cout << i << " " << W << '\n';

            if(W < Min)
            {
                Min = W;
                U = V;
            }
        }

        if(i == K)
        {
            Answer = Min;
        }
        else
        {
            Station[U] = true;
        }
    }

    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

