#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

ll binpow(ll a, ll b)
{
    ll result = 1;
    while(b)
    {
        if(b & 1)
            result *= a;
        a *= a;
        b /= 2;
    }
    return result;
}

ll query(ll n, ll k)
{
    vector < ll > pows;

    while(n)
    {
        pows.push_back(n % k);
        n /= k;
    }

    ll sz = pows.size();

    bool carry = 0;
    ll last = -1;
    for(int i = 0; i < sz; i++)
    {
        if(carry)
        {
            if(pows[i] == 0)
            {
                carry = 0;
                pows[i] = 1;
                last = i;
            }
            else continue;
        }
        else
        {
            if(pows[i] > 1)
            {
                carry = 1;
            }
        }
    }
    if(carry)
    {
        pows.push_back(1);
        last = pows.size() - 1;
    }

    for(int i = 0; i < last; i++)
    {
        pows[i] = 0;
    }

    ll x = 0;
    for(int i = 0; i < pows.size(); i++)
    {
        x = x + pows[i] * binpow(k, i);
    }

    return x;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll q, n, k;
    cin >> q;
    
    for(int i = 1; i <= q; i++)
    {
        cin >> n >> k;
        cout << query(n, k) << endl;
    }

    return 0;
}   