#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 101;
const ll INF = 4e18 + 10;

int n;
int k;
int p[MAXN];
bool used[MAXN];
ll cnt[MAXN];
ll d[MAXN];
ll ans = INF;
ll cur;
vector < vector < int > > combs;
vector < int > comb;

void gen(int pos, int ost)
{
    if(pos == n)
    {
        combs.push_back(comb);
        return;
    }

    if(n - (pos + 1) >= ost || ost == 0)
    {
        comb.push_back(0);
        gen(pos + 1, ost);
        comb.pop_back();
    }

    if(ost > 0)
    {
        comb.push_back(1);
        gen(pos + 1, ost - 1);
        comb.pop_back();
    }
}

void read()
{
    cin >> n >> k;

    for(int i = 2; i <= n + 1; i++)
    {
        cin >> cnt[i] >> p[i] >> d[i];
        p[i]++;
    }
}

void push(int node, int c)
{
    if(node == 1 || used[node])
        return;

   /// cout << "Current node : " << node << endl;

    cur = cur + c * d[node];
   /// cout << "Cost after this move : " << cur << endl;

    push(p[node], c);
}

void solve()
{
    gen(0, k);

    for(vector < int > c : combs)
    {
        used[1] = true;
        cur = 0;
        for(int i = 2; i <= n + 1; i++)
        {
            used[i] = false;
            if(c[i - 2])
                used[i] = true;
        }

        for(int i = 2; i <= n + 1; i++)
        {
            push(i, cnt[i]);
        }

        ans = min(ans, cur);
    }

    cout << ans << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ///cout << "qzh mi chepa" << endl;
    read();

   /// cout << "mina cheteneto" << endl;
    solve();

    ///cout << "daima" << endl;

    return 0;
}
/**
4 0
1 0 1
1 1 10
10 2 5
1 2 3
 */